<?php

namespace Teknisa\ACL\Repositories;

use Doctrine\DBAL\Platforms\SQLAnywhere11Platform;
use Teknisa\ACL\Util\InstanceProvider;

class SqlLogs{


    public function findSqlLogs($filters, $limit, $offset, $bindParams, $typeBindParams, $order){
        $sql = <<<SQL
          SELECT TO_DATE(FIRST_LOAD_TIME, 'YYYY-MM-DD hh24:mi:ss') AS FIRST_LOAD_TIME , TO_CHAR(LAST_ACTIVE_TIME, 'DD/MM/YYYY hh24:mi:ss') AS LAST_ACTIVE_TIME, 
                 PARSING_SCHEMA_NAME, MODULE, ACTION, ELAPSED_TIME, SQL_FULLTEXT
          FROM V\$SQLAREA
          WHERE 1=1
          $filters
          $order
SQL;


        $query = $this->getPaginatedQuery($sql, $limit, $offset);
        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query, $bindParams, $typeBindParams);
    }


    public function getPaginatedQuery($query, $limit, $offset)
    {
        if ($limit > 0) {
            $max = $limit;
            $column = '*';
            if ($offset > 0) {
                $min = $offset + 1;
                $query = 'SELECT * FROM (SELECT a.' . $column . ', rownum AS doctrine_rownum FROM (' .
                    $query .
                    ') a WHERE rownum <= ' . $max . ') WHERE doctrine_rownum >= ' . $min;
            } else {
                $query = 'SELECT a.' . $column . ' FROM (' . $query . ') a WHERE ROWNUM <= ' . $max;
            }
        }
        return $query;
    }

    public function findDbUser(){
        $query = <<<SQL
          SELECT SUBSTR(TRIM(UPPER(SYS_CONTEXT('USERENV', 'SESSION_USER'))), 1, 50) AS DBUSER
          FROM DUAL
SQL;

        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query);
    }
}